SystemOrganization addCategory: #ImageFootprint!

!MethodReference methodsFor: '*ImageFootprint' stamp: 'hjo 3/27/2009 10:54'!
isReal

	"Is this really a method that can be called? Unlike #DoIt."
	^self actualClass canUnderstand: self methodSymbol! !

Object subclass: #ImageFootprint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFootprint'!

!ImageFootprint classSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 09:44'!
initialize

	self new go! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:15'!
dumpClasses

	self dumpClassesOn: (FileStream newFileNamed: self filepathForDumpClasses)! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:15'!
dumpClassesOn: aStream

	'Printing classes'
		displayProgressAt: Sensor cursorPoint for: (Smalltalk allClasses sortBy: #name ascendingSortBlock) do: [:c| aStream nextPutAll: (c definition copyWithoutAll: String crlf) ; cr ] 


! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:22'!
dumpMethods

	self dumpMethodsOn: (FileStream newFileNamed: self filepathForDumpMethods)! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:16'!
dumpMethodsOn: aStream

	| cm |
		'Printing methods'
				displayProgressAt: Sensor cursorPoint for: ((CompiledMethod allInstances collect: [:e| e methodReference ]) reject: [:each| each isNil]) asSortedCollection 
 		do: [:m| |vs| vs:= m stringVersion.
			vs isNil ifTrue: [ vs:= m stringVersionDefault ].
			vs notNil ifTrue: [
				(m notNil and: [m actualClass notNil and:[m isReal]])
					ifTrue: [
						cm := m compiledMethod.
						aStream nextPutAll: vs; nextPutAll: '    ----'; nextPutAll: cm timeStamp; cr]] ]

! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 3/27/2009 10:58'!
fileStem

	^FileDirectory baseNameFor: (FileDirectory localNameFor: SmalltalkImage current imageName)! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:01'!
filepathForDumpClasses

	^self fileStem , '.classDump'! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:02'!
filepathForDumpMethods

	^self fileStem , '.methodDump'! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:24'!
filepathForImageFootprint

	^self fileStem , '.imageFootprint'! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:07'!
fullFilepathForDumpClasses

	^FileDirectory fullPathForURI: self filepathForDumpClasses! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:07'!
fullFilepathForDumpMethods

	^FileDirectory fullPathForURI: self filepathForDumpMethods! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:24'!
fullFilepathForImageFootprint

	^FileDirectory fullPathForURI: self filepathForImageFootprint! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:08'!
fullFilepaths

	^Array with: self fullFilepathForDumpClasses with: self fullFilepathForDumpMethods! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:32'!
go

	|stream|
	stream := FileStream newFileNamed: self filepathForImageFootprint.
	self dumpClassesOn: stream.
	self dumpMethodsOn: stream.
	stream close.
	self beep: 'croak'
! !
ImageFootprint initialize!
